package local;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import java.io.*;
import java.net.*;

import remote.Command;
import remote.CommandException;

public abstract class RemoteTask extends Task
{
	private String _sMachine = null;
	private int _iPort = -1;
	protected PrintWriter _printWriter = null;
	protected BufferedReader _bufferedReader = null;

	protected Command _command = null;

	private Socket _socket = null;

	protected Socket getSocket()
	{
		return _socket;
	}

	// The method executing the task
	public void execute() throws BuildException
	{
		if ( _sMachine == null || _iPort == -1)
		{
			throw new BuildException("invalid field data");
		}

		try
		{
			// connect to socket
			_socket = new Socket( _sMachine, _iPort);

			// get readers/writers
			ObjectOutputStream out = new ObjectOutputStream( _socket.getOutputStream() );

			// output command
			setCommand();

			out.writeObject(_command);
			out.close();

			_socket.close();
		}
		catch ( IOException ioe)
		{
			throw new BuildException( ioe);
		}
	}

	public abstract void setCommand() throws IOException;

	// The setter for the "machine" attribute
	public void setMachine(String machine)
	{
		_sMachine = machine;
	}

	// the setter for the port attribute
	public void setPort(String port)
	{
		try
		{
			int iPort = Integer.parseInt( port);

			_iPort = iPort;
		}
		catch (NumberFormatException nfe)
		{
			_iPort = -1;
		}
	}
}